InstantFox.applyOverlay = function(off) {
    var $el = InstantFox.$el, $ = InstantFox.$, rem = InstantFox.rem
	var buttonId = 'instantFox-options', popupId = 'instantfox-popup'
	if (off) {
		[
			gNavToolbox.palette.querySelector("#" + buttonId),
			$(buttonId),
			$(popupId)
		].forEach(rem)
		return
	}

	/* devel__) */

	// ---------------------------
	var options = {
		id: popupId, noautohide:'true', position:'after_end',
		persist:'width,height', width:'400', height:'600',
		onpopupshowing: "if(event.target==this)InstantFox.onPopupShowing(this)",
		onpopuphiding: "if(event.target==this)InstantFox.onPopupHiding(this)"
	}
	InstantFox.updatePopupSize(options)
	$el("panel", options, [$el("stack", {flex: 1}, [
		$el('resizer', {element: popupId, dir:'bottomleft',
			left:'0', bottom:'0', width:'16', height:'16', style:'-moz-transform: rotate(90deg);'
		})
	])], $("mainPopupSet"))
	// ---------------------------

	var toolbarButton = $el('toolbarbutton', {type:"menu", popup: popupId, id: buttonId,
		class:'toolbarbutton-1 chromeclass-toolbar-additional',
		image:'chrome://instantfox/content/skin/button-logo.png', label:'InstantFox'
	}, gNavToolbox.palette)

	var id = buttonId
	var selector = "[currentset^='"+id+",'],[currentset*=',"+id+",'],[currentset$=',"+id+"']"
	var toolbar = document.querySelector(selector)
	if (!toolbar)
		return

	var currentset = toolbar.getAttribute("currentset").split(",");
    var i = currentset.indexOf(id) + 1;

    var len = currentset.length, beforeEl;
    while (i < len && !(beforeEl = $(currentset[i])))
		i++

	toolbar.insertItem(id, beforeEl);
}

//************************************************************************
// options popup
InstantFox.popupCloser = function(e) {
	var inPopup = InstantFox.clickedInPopup
	InstantFox.clickedInPopup = false
	if (inPopup || e.target.nodeName == 'resizer')
		return
	if (e.target.id == 'instantFox-options') {
		e.stopPropagation()
		e.preventDefault()
	}
	window.removeEventListener('mousedown', InstantFox.popupCloser, false)
	document.getElementById('instantfox-popup').hidePopup()
}
InstantFox.onPopupShowing = function(p) {
	if (p.id != 'instantfox-popup')
		return

	document.getElementById('instantFox-options').setAttribute("open", true)
	window.addEventListener('mousedown', InstantFox.popupCloser, false)

	var st = p.querySelector('stack')
	var ifr = p.querySelector('iframe')
	if (ifr) {
		// touch the stack, otherwise it isn't drawn in nightly
		st.flex = 0
		st.flex = 1
		// rebuild in case user modified plugins by another options window instance
		try {
			ifr.contentWindow.onOptionsPopupShowing()
		} catch(e){Components.utils.reportError(e)}
		return;
	}
	var ifr = InstantFox.$el('iframe', {
		src: 'chrome://instantfox/content/options.xul',
		flex: '1'
	})
	st.insertBefore(ifr, st.firstChild)
}
InstantFox.onPopupHiding = function(p) {
	var ifr = p.querySelector('iframe')
	ifr.contentWindow.saveChanges()
	window.removeEventListener('mousedown', InstantFox.popupCloser, false)
	document.getElementById('instantFox-options').removeAttribute("open");
}
InstantFox.updatePopupSize = function(options) {
	var RDF = Cc["@mozilla.org/rdf/rdf-service;1"].getService(Ci.nsIRDFService)

	var store = PlacesUIUtils.localStore//this.RDF.GetDataSource("rdf:local-store")

	var root = RDF.GetResource("chrome://browser/content/browser.xul#instantfox-popup");

	var getPersist = function getPersist(aProperty) {
		let property = RDF.GetResource(aProperty);
		let target = store.GetTarget(root, property, true);
		if (target instanceof Ci.nsIRDFLiteral)
			return target.Value;
	}
	options.width  = getPersist("width")  || options.width
	options.height = getPersist("height") || options.height
}
InstantFox.popupClickListener = function(e) {
	InstantFox.clickedInPopup = true
}
InstantFox.closeOptionsPopup = function(p) {
	p = p || document.getElementById('instantfox-popup')
	p.hidePopup()
}
InstantFox.openHelp = function() {
	var url = InstantFoxModule.helpURL
	gBrowser.loadOneTab(url, {inBackground: false, relatedToCurrent: true});
}

// mode = ""           follow prefs
// mode = "install"    remove searchbox and add instantfox button
// mode = "uninstall"  add searchbox if 
InstantFox.updateToolbarItems = function(mode) {		
	var navBar = document.getElementById("nav-bar");
	var curSet = navBar.currentSet.split(",");
	//**********************************************
	var oldId = "search-container"
	var newId = "instantFox-options"
	var getSearchbarPosition = function(){
		var pos = curSet.indexOf("urlbar-container") + 1;
		if (pos) {
			while (
				   curSet[pos] == 'reload-button'
				|| curSet[pos] == 'stop-button'
				|| curSet[pos] == 'search-container'
			) {
				pos++
			}
		} else {
			pos = curSet.length;
		}
		return pos
	}
	var pb = Services.prefs.getBranch("extensions.InstantFox.")
	var getPref = function(name, defVal) {
		if (name in (mode || {}))
			return mode.name
		else if (pb.prefHasUserValue(name))
			return pb.getBoolPref(name)
		else
			return defVal
	}
	//**********************************************



	if (mode == "install"){
		if (!InstantFoxModule._defToolbarSet)
			InstantFoxModule._defToolbarSet = curSet.concat()
		
		var i1 = curSet.indexOf(newId)
		var i2 = curSet.indexOf(oldId)

		if (i1 >= 0 || document.getElementById(newId))
			return
		if (i2 == -1) {
			var pos = getSearchbarPosition()
			curSet.splice(pos, 0, newId)
		} else {
			curSet[i2] = newId
		}
	}
	else if (mode == "uninstall") {
		if (InstantFoxModule._defToolbarSet)
			curSet = InstantFoxModule._defToolbarSet
		else {
			var i1 = curSet.indexOf(newId)
			if (i1 >= 0 && !document.getElementById(oldId))
				curSet[i1] = oldId
		}
	}
	else {
		var item2Toolbar = function(id, remove) {

			var i = curSet.indexOf(id)
			if (remove) {
				i != -1 && curSet.splice(i, 1)
			} else if (i == -1) {
				var pos = getSearchbarPosition()
				curSet.splice(pos, 0, id)
			}
		}
		var removeSearchbar = getPref("removeSearchbar", true)		
		var removeOptions = getPref("removeOptions", false)
		
		item2Toolbar(oldId, removeSearchbar)		
		item2Toolbar(newId, removeOptions)
	}


	//**********************************************
	curSet = curSet.join(",")
	if (curSet != navBar.currentSet){
		navBar.setAttribute("currentset", curSet);
		navBar.currentSet = curSet;
		document.persist(navBar.id, "currentset");
		try {
			BrowserToolboxCustomizeDone(true);
		} catch (e) {}
	}
}

InstantFox.updateToolbarPrefs = function(e) {
	InstantFoxModule._defToolbarSet = null
	var optionsButton = document.getElementById("instantFox-options")
	var searchBar = document.getElementById('search-container')

	Services.prefs.setBoolPref("extensions.InstantFox.removeSearchbar", !searchBar)
	Services.prefs.setBoolPref("extensions.InstantFox.removeOptions", !optionsButton)

}

